<?php
/*
 #########################################################################
 #                       xt:Commerce Shopsoftware
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # Copyright 2021 xt:Commerce GmbH All Rights Reserved.
 # This file may not be redistributed in whole or significant part.
 # Content of this file is Protected By International Copyright Laws.
 #
 # ~~~~~~ xt:Commerce Shopsoftware IS NOT FREE SOFTWARE ~~~~~~~
 #
 # https://www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # @copyright xt:Commerce GmbH, www.xt-commerce.com
 #
 # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 #
 # xt:Commerce GmbH, Maximilianstrasse 9, 6020 Innsbruck
 #
 # office@xt-commerce.com
 #
 #########################################################################
 */
  
defined('_VALID_CALL') or die('Direct Access is not allowed.');  

global $xtPlugin, $language;

if(isset($xtPlugin->active_modules['xt_blog']) && $xtPlugin->active_modules['xt_blog'] == true){

    global $xtLink;
    include_once _SRV_WEBROOT.'plugins/xt_blog/classes/class.xt_blog_helper.php';
    $blog_helper = new xt_blog_helper();
    $blog_helper->cron_action();

    include_once _SRV_WEBROOT.'plugins/xt_blog/classes/class.xt_blog_messages.php';
    $b_messages = new xt_blog_messages();

    if(empty($params)) $params = [];

      if($params['box_type'] == 'categories')
      {
      	$box_type = 'categories';
      }
      else if($params['box_type'] == 'featured_messages')
      {
      	$box_type = 'featured_messages';
      }
      else if($params['box_type'] == 'latest_comments')
      {
          $box_type = 'latest_comments';
      }
	  else if($params['box_type'] =='cross_selling')
	  {
		 $box_type = 'cross_selling';
	  }
	   else 
      {
          $box_type = 'messages';
      }

      $blog_header = array();
      $blog_header['title'] = PLUGIN_BLOG_TITLE;
      $blog_header['description'] = PLUGIN_BLOG_DESCRIPTION;

      if (($box_type == 'messages') or ($box_type == '')) {

            $BlogCat = 0;
            $BlogDeep = 99;
            $BlogMax = PLUGIN_BLOG_FEED_MAX;

            if($params['cat'] != '' ) $BlogCat= (int)$params['cat'];
            if($params['deep'] != '' ) $BlogDeep = (int)$params['deep'];
            if($params['max'] != '' ) $BlogMax = (int)$params['max'];
            if($params['d'] != '' ) $box_type = $params['d'];

            $blog_messages = $b_messages->get_messages($BlogCat, $BlogDeep, $BlogMax, false);   
            foreach($blog_messages['data'] as $key => $item) {
                $blog_messages['data'][$key]['link'] = $blog_helper->get_message_link($item);
                $blog_messages['data'][$key]['pubdate'] = $item['public_start_date']; 
            }        
      }
    //  debugbreak();
      if ($box_type == 'categories')  {
          $link_blog = $xtLink->_link(array('page'=>XT_BLOG_PAGE));                 
          $blog_categories_list = '<a href="'.$link_blog.'"><span>'.TEXT_BLOG_CATEGORIES_ALL.'</span></a><br />';
          $blog_categories = $blog_helper->getBlogCategories_box();
          $blog_categories_list .= $blog_helper->sortSubCategories_to_ul(0, $blog_categories);
		  
		 if ($params['tpl']=='') $params['tpl'] = PLUGIN_BLOG_BOX_XT_BLOG_CATEGORY;

      } 
      
      if($box_type == 'featured_messages')
      {
      	if(!isset($params['limit']) || (int)$params['limit'] <= 0) 
      		$limit_messages = PLUGIN_BLOG_PAGE_MAX;
      	else
      		$limit_messages = $params['limit'];

      	$blog_messages = $b_messages->getFeaturedMessages($limit_messages);

      	foreach($blog_messages['data'] as $key => $item) 
		{
      		$blog_messages['data'][$key]['link'] = $blog_helper->get_message_link($item);
      		$blog_messages['data'][$key]['pubdate'] = $item['public_start_date'];
      	}
      	
      	if ($params['tpl']=='') $params['tpl'] = 'box_xt_blog.html';
      }
	  
	  if($box_type == 'latest_comments')
      {
			$limit = (isset($params['limit']) && (int)$params['limit'] != 0 ? $params['limit'] : 5);
			$message_id = (isset($params['message_id']) && (int)$params['message_id'] != 0 ? $params['message_id'] : false);
			
			$blog_helper->cron_action();
			$comments = $blog_helper->getLatestComments($limit, $message_id);

			if ($params['tpl']=='') $params['tpl'] = 'box_xt_blog_latest_comments.html';
			
      }
	  
		 if($box_type == 'cross_selling')
	  {

	
		include_once _SRV_WEBROOT.'plugins/xt_blog/classes/class.cross_selling_blog_message.php';
		
		if ($_GET['bmid'])
		{
			$cross_selling = new cross_selling_blog_message_list(0);
			$_cross_selling =  $cross_selling->_display($_GET['bmid']);
		}
		
		if ($params['tpl']=='') $params['tpl'] = 'box_xt_blog_message_cross_selling.html';
		
	  
	  }
      $rss_feeds = array();
		$seo_url = $xtLink->_link(array('page'=>'blog'));
		
    $xtBlogLink = XT_BLOG_URL;
			
    if (_SYSTEM_SEO_URL_LANG_BASED == "true") {
        $xtBlogLink = $language->code . "/" . $xtBlogLink;
    }
    $rss_feeds[] = array('title' => TEXT_XT_BLOG_RSS2_ABONNIEREN, 'link' => $xtLink->_link(array('page'=> XT_BLOG_PAGE,'paction'=>'feed_rss2','seo_url'=>$xtBlogLink)));
    $rss_feeds[] = array('title' => TEXT_XT_BLOG_ATOM_ABONNIEREN, 'link' => $xtLink->_link(array('page'=> XT_BLOG_PAGE,'paction'=>'feed_atom','seo_url'=>$xtBlogLink)));


     $tpl_data = array('blog_categories_list' => $blog_categories_list, 'blog_messages' => $blog_messages['data'], 'blog_header' => $blog_header, 'rss_feeds' => $rss_feeds,'blog_categories' =>$blog_categories,'blog_latest_comments'=>$comments,'_cross_selling'=>$_cross_selling);
    $show_box = true;    
}else{
    $show_box = false;
}
